<?php
    global $CFG;

    require_once('../../config.php');
    require_once('objectives.php');
    require_login();

    if (!isset($CFG->teacherplan_designationseparator)) {
        $CFG->teacherplan_designationseparator = '-';
    }

    $showcourses = isadmin();

    if (!$site = get_site()) {
        error("Site isn't defined!");
    }
    
    $sep = $CFG->teacherplan_designationseparator; 

    $courseid   = optional_param('courseid', 0, PARAM_INT);        // Course Module ID
    $courseobj  = optional_param('courseobjectives', 0, PARAM_INT);
    $coursepar  = optional_param('coursepar', '', PARAM_NOTAGS);
    $coursepar = trim($coursepar);
    $newobjtext = optional_param('newobjectivetext', '', PARAM_NOTAGS);
    $newobjtext = trim($newobjtext);
    $newobjdes  = optional_param('newobjectivedes', 0, PARAM_NOTAGS);
    $newobjdes = trim($newobjdes);
    $standardid = optional_param('standard', -1, PARAM_INT);
    $fromform   = optional_param('parent', '', PARAM_NOTAGS);
    $reactfunc  = optional_param('react', '', PARAM_NOTAGS);
    if (optional_param('getobjs', '', PARAM_NOTAGS) != '') {
        $submitType = 'getobjs';
    } else if (optional_param('findcourse', '', PARAM_NOTAGS) != '') {
        $submitType = 'findcourse';
    } else if (optional_param('saveobjs', '', PARAM_NOTAGS) != '') {
        $submitType = 'saveobjs';
    } else if (optional_param('addobj', '', PARAM_NOTAGS) != '') {
        $submitType = 'addobj';
    } else if (optional_param('replaceobj', '', PARAM_NOTAGS) != '') {
        $submitType = 'replaceobj';
    } else if (optional_param('deleteobj', '', PARAM_NOTAGS) != '') {
        $submitType = 'deleteobj';
    } else {
        $submitType = 'none';
    }

    $strnoupdate = get_string('noupdateobjectives', 'teacherplan');
    $stradmin = get_string('administration');
    $strconfiguration = get_string('configuration');
    $strmanagemodules = get_string('managemodules');
    $strteacherplan = get_string('modulename', 'teacherplan');
    $strbenchmarktitle = get_string('benchmarkedittitle', 'teacherplan');
    $strnodelete = get_string('nodeleteobjectives', 'teacherplan');
    $strnoadd = get_string('noaddobjectives', 'teacherplan');
    $strnodeletemet = get_string('nodeleteobjectivesmet', 'teacherplan');
    $strnoupdate = get_string('noupdateobjectives', 'teacherplan');

    if ($submitType == 'addobj') {
        if (!empty($newobjtext)) {
            $objectiverecord->course = $courseid;
            $objectiverecord->objective = $newobjtext;
            $objectiverecord->name = $newobjdes;
            if ($standardid >= 0) {
                $objectiverecord->standardid = $standardid;
            }
            $objectiverecord->timemodified = time();
            if (!insert_record('teacherplan_objectives', $objectiverecord)) {
                error($strnoadd);
            }
        }
    } elseif ($submitType == 'deleteobj') {
        if (!delete_records('teacherplan_objectives', 'id', $courseobj)) {
          error($strnodelete);
        }

        if (!delete_records('teacherplan_objectives_met', 'objectiveid', $courseobj)) {
          error($strnodeletemet);
        }
    } elseif ($submitType == 'replaceobj') {
        $objectiverecord->course = $courseid;
        $objectiverecord->id = $courseobj;
        $objectiverecord->name = $newobjdes;
        $objectiverecord->objective = $newobjtext;
        if ($standardid >= 0) {
            $objectiverecord->standardid = $standardid;
        }
        $objectiverecord->timemodified = time();

        if (!update_record('teacherplan_objectives', $objectiverecord)) {
           error($strnoupdate);
        }
    } else {
        add_to_log($courseid, 'teacherplan', 'view objectives', 'configtp.php');
    }
?>

<script language="JavaScript" type="text/javascript">
<!--
    function updateAndClose() {
<?php 
    if (!empty($fromform)) {
        echo 'opener.updateObjectives(document.cfgform.courseobjectives, "'.$fromform."[]\"";
        if (!empty($reactfunc)) {
            echo ', "'.$reactfunc.'"';
        }
        echo ");\n";
    }
?>
    self.close();
    }
-->
</script>

<?php 

    print_header();
    print_heading($strbenchmarktitle);

    print_simple_box_start("center", "");
    
    $deslist = '';
    $standlist = '';
    $i = 0;
    if (!empty($courseid)) {
        if ($objectives = teacherplan_get_objectives_array(-1, $courseid)) {
            foreach ($objectives as $objective) {
                $deslist[$i] = $objective->name;
                $standlist[$i++] = $objective->standardid;
            }
        }
    }
?>
<script language="JavaScript" type="text/javascript">
<!--
<?php 
    echo 'var objdeslist = [';
    for ($i = 0; $i < count($deslist); $i++) {
        if ($i > 0) {
            echo ', ';
        }
        echo "'".$deslist[$i]."'";
    }
    echo "];\n";
    
    echo 'var objstandlist = [';
    for ($i = 0; $i < count($standlist); $i++) {
        if ($i > 0) {
            echo ', ';
        }
        echo "'".$standlist[$i]."'";
    }
    echo "];\n";
?>
    function courseClick(){
        var courseList = document.cfgform.elements["courseid"];
        
        for (var i=0; i < courseList.options.length; i++) {
            if (courseList.options[i].selected){
              location.replace("http://"+location.hostname+location.pathname+"?courseid="+courseList.options[i].value+"&getobjs=&coursepar=<?php echo $coursepar ?>");
            }
        } 
    }
    
    function selectFromList()
    {
        var df = document.cfgform;
        var objectivelist = df.elements["courseobjectives"];
        var disableme = objectivelist.options.length == 0;
        
        df.newobjectivetext.value = objectivelist.options[objectivelist.selectedIndex].text;
        df.newobjectivedes.value = objdeslist[objectivelist.selectedIndex];
        for (var i=0; i < df.standard.options.length; i++) {
            df.standard.options[i].selected = (df.standard.options[i].value == objstandlist[objectivelist.selectedIndex]);                
        } 
        document.cfgform.replaceobj.disabled = disableme;
        document.cfgform.deleteobj.disabled = disableme;
    }
-->
</script>

<form name="cfgform" method="post" action="<?php echo $CFG->wwwroot.'/mod/teacherplan/configtp.php' ?>" >
<?php if ($showcourses) { ?>
    <input type="hidden" name="id" value="<?php echo $courseid ?>" />
<?php } else { ?>
    <input type="hidden" name="courseid" value="<?php echo $courseid ?>" />
<?php } ?>    
<input type="hidden" name="sesskey" value="<?php echo sesskey(); ?>" />
<input type="hidden" name="parent" value="<?php echo $fromform ?>" />
<input type="hidden" name="react" value="<?php echo $reactfunc ?>" />

<table cellpadding=2 cellspacing=1 border=1>
<tr>
<?php if ($showcourses) { ?>
<th align="center" style="width: 250px"><?php print_string('configobjfromcoursetitle', 'teacherplan') ?></th>
<?php } ?>
<th align="center" style="width: 400px">
<?php
    if (!empty($courseid)) {
        if (! $localcourse = get_record("course", "id", $courseid)) {
            error(get_string('errcoursemisconfigured', 'teacherplan'));
        }
        print_string('configbenchmarklist', 'teacherplan', $localcourse->shortname);
        echo "&nbsp;<input type=\"button\" name=\"importobj\" value=\"".get_string('importobjtext', 'teacherplan')."...\" onclick=\"return openpopup('/mod/teacherplan/importstandbench.php?courseid=".$courseid."&type=benchmarks&returnurl=".$CFG->wwwroot."/mod/teacherplan/configtp.php?courseid=".$courseid."','importbench','height=800,width=620,resizable=true', false);\">";
    } else {
        print_string('confignobenchmarksyet', 'teacherplan');
    }
?>
</th>
</tr>
<tr>
<?php if ($showcourses) { ?>
<td style="width: 250px">
<select name="courseid" style="width: 240px" id="courseid" size=15 onchange="return courseClick()">
<?php
        $fieldsearch = '';
        if (!empty($coursepar)) {
            $fieldsearch = "fullname LIKE '%".$coursepar."%' OR shortname LIKE '%".$coursepar."%'";
        }
        $courses = get_records_select('course', $fieldsearch, "fullname", "id,fullname,shortname");
        
        if (!empty($courses)) {
            foreach ($courses as $acourse) {
                echo '<option value="'.$acourse->id.'"';
                if ($acourse->id == $courseid) {
                    echo ' selected';
                }
                echo '>'.$acourse->fullname.':'.$acourse->shortname.'</option>';
            }
        }
?>
</select>
</td>
<?php } ?>
<td style="width: 400px">
<?php
    print_objectives_selectbox($courseid, 0, 'courseobjectives', false, 'return selectFromList()', 'width: 600px', 15, false);
?>
</td>
</tr>
<tr>
<?php if ($showcourses) { ?>
<td style="width: 250px" valign="top">
<input type="submit" name="findcourse" value="<?php print_string('searchcourse', 'teacherplan') ?>" >
<input type="text" name="coursepar" value="<?php echo $coursepar ?>" size=10><br>
</td>
<?php } ?>
<td align="left"  style="width: 400px">
    <?php print_string('objectivelabel', 'teacherplan') ?>:
    <input type="text" name="newobjectivetext" value="" size="80" maxlength="255">
    <br>
    <?php print_string('benchmarkdesiglabel', 'teacherplan') ?>:
    <input type="text" name="newobjectivedes" value="" size="5" maxlength="20">
    <br>
    <?php print_string('standardlabel', 'teacherplan') ?>:
    <select name="standard" style="width: 300px" id="standard">
<?php
    if (!empty($courseid)) {
        echo '<option value="-1">'.get_string('nostandardselected', 'teacherplan').'</option>';
        if ($standards = get_records('teacherplan_standards', 'course', $courseid, 'parentid,name,standard')) {
            foreach ($standards as $standard) {
                $standardname = $standard->name;
                $parentid = $standard->parentid;
                while ($parentrec = get_record('teacherplan_standards', 'id', $parentid)) {
                    $standardname = $parentrec->name.$sep.$standardname;
                    $parentid = $parentrec->parentid;
                }
                echo '<option value="'.$standard->id.'">'.$standardname.' '.$standard->standard.'</option>';
            }
        }
    }
?>
    </select>
    <input type="button" name="importstand" value="<?php echo get_string('importstandtext', 'teacherplan').'...' ?>" onclick="return openpopup('/mod/teacherplan/importstandbench.php?courseid=<?php echo $courseid ?>&type=standards&returnurl=<?php echo $CFG->wwwroot.'/mod/teacherplan/configtp.php?courseid='.$courseid ?>','importstand','height=700,width=620', false);"><br><br>
    <center>
    <input type="submit" name="addobj" value="<?php print_string('addobjectivestexttitle', 'teacherplan') ?>">&nbsp;&nbsp;&nbsp;
    <input type="submit" name="replaceobj" value="<?php print_string('replaceobjectivestexttitle', 'teacherplan') ?>">&nbsp;&nbsp;&nbsp;
    <input type="submit" name="deleteobj" value="<?php print_string('deleteobjectivestexttitle', 'teacherplan') ?>">
    </center>
</td>
</tr></table>
</form>
<center>
<hr>
<input type="button" name="finished" value="<?php print_string('configdonebtn', 'teacherplan') ?>" onclick="return updateAndClose()">
</center>
<script language="JavaScript" type="text/javascript">
<!--
<?php if ($showcourses) { ?>
    var courseselected = false;
    var courseList = document.cfgform.elements["courseid"];
        
    for (var i=0; i < courseList.options.length; i++) {
        if (courseList.options[i].selected){
            courseselected = true;
            break;
        }
    }
    document.cfgform.elements["addobj"].disabled = !courseselected;
    document.cfgform.elements["getobjs"].disabled = !courseselected;
    document.cfgform.elements["importobj"].disabled = !courseselected;                 
    document.cfgform.elements["importstand"].disabled = !courseselected;                 
<?php } else { ?>
    document.cfgform.elements["importobj"].disabled = false;
    document.cfgform.elements["importstand"].disabled = false;
<?php } ?>        
    document.cfgform.replaceobj.disabled = true;
    document.cfgform.deleteobj.disabled = true;  
-->
</script>

<?php 
    print_simple_box_end();
    
?>