<?php
    global $CFG;

    require_once("../../config.php");
    require_login();

    if (!isset($CFG->teacherplan_designationseparator)) {
        $CFG->teacherplan_designationseparator = '-';
    }

    $courseid   = optional_param('courseid', 0, PARAM_INT);        // Course Module ID
    $importtype = optional_param('type', '', PARAM_ALPHA);
    $returnurl  = optional_param('returnurl', '', PARAM_NOTAGS); 
    $text       = optional_param('textdata', '', PARAM_NOTAGS);
    $text = trim($text);
    
    $sep = $CFG->teacherplan_designationseparator; 
    $close = false;
    if ($importtype == 'benchmarks') {
        $savestr = get_string('configsavebenchmarks', 'teacherplan');
        $table = 'teacherplan_objectives';
        $subtable = 'teacherplan_objectives_met';
        $subtablekey = 'objectiveid';
        $subtablevalue = 0;
        $deletekey = true;
        $orderby = 'standardid,name,objective';
        $field0 = 'name';
        $field1 = 'objective';
        $strnoupdate = get_string('noupdateobjectives', 'teacherplan');
        $notextentered = get_string('confignobenchmarksgiven', 'teacherplan');
        $headerstr = get_string('importobjtext', 'teacherplan');
        $titletext = get_string('objectivestexttitle', 'teacherplan');
        $desclower = get_string('objectivelabellower', 'teacherplan');
        $strnodeletemain = get_string('nodeleteobjectives', 'teacherplan');
        $strnoupdatesub = get_string('nodeleteobjectivesmet', 'teacherplan');
    } else if ($importtype == 'standards') {
        $savestr = get_string('configsavestandards', 'teacherplan');
        $table = 'teacherplan_standards';
        $subtable = 'teacherplan_objectives';
        $field0 = 'name';
        $field1 = 'standard';
        $subtablekey = 'standardid';
        $subtablevalue = 0;
        $deletekey = false;
        $orderby = 'parentid,name,standard';
        $strnoupdate = get_string('noupdatestandards', 'teacherplan');
        $notextentered = get_string('confignostandardsgiven', 'teacherplan');
        $headerstr = get_string('importstandtext', 'teacherplan');
        $titletext = get_string('standardstexttitle', 'teacherplan');
        $desclower = get_string('standardlabellower', 'teacherplan');
        $strnodeletemain = get_string('nodeletestandards', 'teacherplan');
        $strnoupdatesub = get_string('noupdateobjectives', 'teacherplan');
    } else {
        $close = true;
    }
    
    if (optional_param('save', '', PARAM_NOTAGS) != '') {
        if (!empty($courseid) and !empty($text)) {
            $textarray = explode("\n", $text);//Extract the objectives
            
            //Clear the existing objectives/standards
            if (!delete_records($table, 'course', $courseid)) {
                error($strnodeletemain);
            }
            if ($deletekey) {
                if (!delete_records($subtable, 'course', $courseid)) {
                    error($strnoupdatesub);
                }
            } else {
                if (!execute_sql('UPDATE '. $CFG->prefix . $subtable .' SET '. $subtablekey .'='. $subtablevalue.' where course='.$courseid)) {
                    error($strnoupdatesub);
                }
            } 
            
            foreach ($textarray as $newitem) {
                unset($insertrec);
                $insertrec->course = $courseid;

                $ifields = explode(',', $newitem, 3);
                
                $standlink = explode($sep, $ifields[0]);
                unset($lastrec);
                if (!empty($standlink)) {
                    foreach ($standlink as $item) {
                        $select  = 'select * from '.$CFG->prefix.'teacherplan_standards where ';
                        $select .= "course = '".$courseid."' and name = '".$item."' and ";
                        if (isset($lastrec)) {
                            $select .= "parentid = '".$lastrec->id."'";
                        } else {
                            $select .= "parentid is null";
                        }
                        $lastrec = get_record_sql($select); 
                        
                        if (empty($lastrec)) {
                            unset($lastrec);
                            break;
                        }
                    }
                }
                
                if (isset($lastrec)) {
                    $standardid = $lastrec->id;
                } else {
                    $standardid = -1;
                }
                
                $insertrec->name = addslashes($ifields[1]);
                if ($importtype == 'standards') {
                    $insertrec->standard = addslashes($ifields[2]);
                    if ($standardid !== -1) {
                        $insertrec->parentid = $standardid;
                    }
                } elseif ($importtype == 'benchmarks') {
                    $insertrec->objective = addslashes($ifields[2]);
                    $insertrec->standardid = $standardid;
                }
                
                $insertrec->timemodified = time();
                if (!insert_record($table, $insertrec)) {
                    error($strnoupdate);
                }
            }
            $close = true;
        } else {
            echo "\n".'<script language="JavaScript" type="text/javascript"><!-- ';
            if (empty($text)) {
                echo 'alert('.$notextentered.');';
            } else { //Must be an empty courseid
                echo 'alert('.get_string('courseunknown', 'teacherplan').');';
            }
            echo ' --></script>';
            $close = false;
        }
    } elseif (optional_param('cancel', '', PARAM_NOTAGS) != '') {
        $close = true;
    }

    if ($close) {
?>
<script language="JavaScript" type="text/javascript">
<!--
    opener.location.replace('<?php echo $returnurl ?>');
    self.close();
-->
</script>
<?php
    } else {
        print_header();
        print_heading($headerstr);
        print_simple_box_start("center", "");
?>
<form name="form" method="post" action="<?php echo "$CFG->wwwroot/mod/teacherplan/importstandbench.php" ?>">
<input type="hidden" name="courseid" value="<?php echo $courseid ?>">
<input type="hidden" name="type" value="<?php echo $importtype ?>">
<input type="hidden" name="returnurl" value="<?php echo $returnurl ?>">
<table cellpadding=2 cellspacing=1>
<tr>
<td style="width: 560px" align="left">
<font size=-1><?php print_string('configimportinfo', 'teacherplan', $desclower) ?></font>
</td>
</tr>
<tr>
<td style="width: 560px">
<textarea name="textdata" id="textdata" style="width:550px" rows=20>
<?php
        $firsttime = true;
        if (!empty($courseid)) {
            $data = get_records($table, 'course', $courseid, $orderby);
            foreach ($data as $item) {
                $itemarr = (array)$item;
                if ($firsttime) {
                    $firsttime = false;
                } else {
                    echo "\n";                
                }  
                
                if ($importtype == 'benchmarks') {
                    $parentrec = get_record('teacherplan_standards', 'id', $item->standardid);
                }
                
                $item0 = '';
                do
                {
                    if (!empty($item0)) {
                        $item0 = $sep.$item0;
                    }
                    
                    if (isset($parentrec)) {
                        $standardid = $parentrec->parentid;
                        $item0 = $parentrec->name.$item0;
                    } elseif ($importtype == 'standards') {
                        $standardid = $item->parentid;    
                    }
                    
                    if (isset($standardid)) {
                        $parentrec = get_record('teacherplan_standards', 'id', $standardid);
                    } else {
                        unset($parentrec);
                    }
                } while (!empty($parentrec));
                
                $item1 = isset($itemarr[$field0]) ? $itemarr[$field0] : ''; 
                $item2 = isset($itemarr[$field1]) ? $itemarr[$field1] : ''; 
                echo $item0.','.$item1.','.$item2;
            }                                                                 
        }                                                                      
?>
</textarea>
</td>
</tr>
<tr>
<td align="center">
<input type="submit" name="save" id="save" value="<?php echo $savestr ?>" ><br>
<input type="submit" name="cancel" id="cancel" value="<?php print_string('cancelimport', 'teacherplan') ?>"><br> 
<?php print_string("configsavewarning", 'teacherplan', $titletext) ?>
</td>
</tr>
</table>
</form>
<?php 
        print_simple_box_end();
    }//end else of if ($close)
?>
