<?php  // $Id: lib.php,v 1.5 2006/07/27 08:14:15 scarletpumpkin Exp $
/** Heavily borrowed from resource/html module, with changes as needed.
*   Original Moodle version at borrowing time was 1.5.3
*/
require_once("objectives.php");

function teacherplan_search_form($narrow=true, $formname='search', $submittext='Go>', $searchform='') {
    global $CFG;
    
    if (empty($searchform)) {
        unset($searchform);
        $searchform->teacher = '';
        $searchform->courseid = '';
        $searchform->plandata = '';
        $searchform->fromdate = time();
        $searchform->todate = time();
        $searchform->maxtosee = 10;
        $searchform->includeassignments = false;
    } else {
        if (empty($searchform->fromdate)) {
            $searchform->fromdate = make_timestamp($searchform->fromyear, $searchform->frommonth, $searchform->fromday, 0, 0);
        }

        if (empty($searchform->todate)) {
            $searchform->todate = make_timestamp($searchform->toyear, $searchform->tomonth, $searchform->today, 0, 0);
        }
    }

    $text = '<form name="'.$formname.'" action="'.$CFG->wwwroot.'/mod/teacherplan/search.php" style="display:inline">';

    $text .= get_string('teachertitle', 'teacherplan').':';
    $text .= '<input name="teacher" type="text" size="12" value="'.$searchform->teacher.'" alt="teacher" />';
    if ($narrow) {
        $text .= '<br />';
    } else {
        $text .= '&nbsp;&nbsp;';
    }
    $text .= get_string('coursetitle', 'teacherplan').':';
    $text .= '<input name="courseid" type="text" size="12" value="'.$searchform->courseid.'" alt="coursename" />';
    if ($narrow) {
        $text .= '<br />';
    } else {
        $text .= '&nbsp;&nbsp;';
    }
    $text .= get_string('plansearchtitle', 'teacherplan').':';
    $text .= '<input name="plandata" type="text" size="12" value="'.$searchform->plandata.'" alt="plandata" />';
    if ($narrow) {
        $text .= '<center>';
    } else {
        $text .= '<br />';
    }
    $text .= "Between ";
    $text .= teacherplan_get_date_selector('fromday', 'frommonth', 'fromyear', $searchform->fromdate);
    $text .= " and ";
    if ($narrow) {
        $text .= '<br />';
    } else {
        $text .= '&nbsp;&nbsp;';
    }

    $text .= teacherplan_get_date_selector('today', 'tomonth', 'toyear', $searchform->todate);
    if ($narrow) {
        $text .= '</center>';
    }

    $text .= '<br />';
    $text .= get_string('showrecs', 'teacherplan').':';
    $text .= '<input name="maxtosee" type="text" size="2" value="'.$searchform->maxtosee.'" alt="maxtosee" />';
    if ($narrow) {
        $text .= '<br /><center>';
    } else {
        $text .= '&nbsp;&nbsp;';
    }
    $text .= get_string('searchassignments', 'teacherplan');
    $text .= '<input name="incasgn" type="checkbox" value="yes" ';
    if ($searchform->includeassignments) {
        $text .= 'checked ';
    }
    $text .= 'alt="incasgn" />';
    if ($narrow) {
        $text .= '<br />';
    } else {
        $text .= '&nbsp;&nbsp;';
    }
    $text .= '<input value="'.$submittext.'" type="submit" />';
    if ($narrow) {
        $text .= '</center>';
    }
    $text .= helpbutton("search", get_string("searchhelptitle", "teacherplan"), "teacherplan", true, true, '', true);

    $text .= '</form>';
    return $text;
}

function teacherplan_get_date_selector($day, $month, $year, $currenttime=0) {
    
    if (empty($currenttime)) {
        $currenttime = time();
    }
    $currentdate = usergetdate($currenttime);

    for ($i=1; $i<=31; $i++) { 
       $days[$i] = $i;
    }
    for ($i=1; $i<=12; $i++) {
       $months[$i] = substr(userdate(gmmktime(12,0,0,$i,1,2000), "%B"), 0, 3);
    }
    for ($i=2000; $i<=2010; $i++) { 
       $years[$i] = $i; 
    }

    $retval = choose_from_menu($days, $day, $currentdate['mday'], '', '', 0, true);
    $retval .= '&nbsp;'.choose_from_menu($months, $month, $currentdate['mon'], '', '', 0, true);
    $retval .= '&nbsp;'.choose_from_menu($years, $year, $currentdate['year'], '', '', 0, true);

    return $retval; 
}

/**
* Functions needed by Moodle
*/
function teacherplan_add_instance($teacherplan) {
// Given an object containing all the necessary data,
// (defined by the form in mod.html) this function
// will create a new instance and return the id number
// of the new instance.

    $teacherplan->timemodified = time();
    $teacherplan->plandate = make_timestamp($teacherplan->planyear, $teacherplan->planmonth, $teacherplan->planday, 0, 0); 
    if (!$teacherplan->multiday) {
        $teacherplan->planenddate = $teacherplan->plandate;
    } else {
        $teacherplan->planenddate = make_timestamp($teacherplan->planendyear, $teacherplan->planendmonth, $teacherplan->planendday, 0, 0);
    }

    $retval = insert_record("teacherplan", $teacherplan);

//Handle objectives table
    if (!empty($teacherplan->objectives)) {//Comes in as a string of ids
        $objectives = explode(':', $teacherplan->objectives);
        foreach ($objectives as $objectiveid) {
            if (!empty($objectiveid)) {
                $objectiverecord->course = intval($teacherplan->course);
                $objectiverecord->planid = intval($retval);
                $objectiverecord->objectiveid = intval($objectiveid);
                $objectiverecord->timemodified = $teacherplan->timemodified;
    
                if (!insert_record("teacherplan_objectives_met", $objectiverecord)) {
                   error("Could not update the teacherplan objectives met", "view.php?id=$teacherplan->id");
                }
            }
        }
    }

    return $retval;
}

function teacherplan_update_instance($teacherplan) {
// Given an object containing all the necessary data,
// (defined by the form in mod.html) this function
// will update an existing instance with new data.

    $teacherplan->id = $teacherplan->instance;
    $teacherplan->timemodified = time();
    $teacherplan->plandate = make_timestamp($teacherplan->planyear, $teacherplan->planmonth, $teacherplan->planday, 0, 0); 
    if (!$teacherplan->multiday) {
        $teacherplan->planenddate = $teacherplan->plandate;
    } else {
        $teacherplan->planenddate = make_timestamp($teacherplan->planendyear, $teacherplan->planendmonth, $teacherplan->planendday, 0, 0);
    }

//Handle objectives table
    $usedobjectiveids = '';
    if (!empty($teacherplan->objectives)) {
        $objectives = explode(':', $teacherplan->objectives);
        foreach ($objectives as $objectiveid) {
            if (!empty($objectiveid)){
                $usedobjectiveids = empty($usedobjectiveids) ? strval($objectiveid) : $usedobjectiveids.",".strval($objectiveid);
                if (! $oldrecord = get_record("teacherplan_objectives_met", "planid", $teacherplan->id, "objectiveid", $objectiveid)) {
    
                     $objectiverecord->course = intval($teacherplan->course);
                     $objectiverecord->planid = intval($teacherplan->id);
                     $objectiverecord->objectiveid = intval($objectiveid);
                     $objectiverecord->timemodified = $teacherplan->timemodified;
                     if (!insert_record("teacherplan_objectives_met", $objectiverecord)) {
                        error("Could not update the teacherplan objectives met", "view.php?id=$teacherplan->id");
                     }
                }
            }
        }
    }

    unset($teacherplan->objectives);

// Remove unused (unselected) objectives from the "met" table
    if (empty($usedobjectiveids)) {
        delete_records("teacherplan_objectives_met", "planid", $teacherplan->id);
    } else {
        delete_records_select("teacherplan_objectives_met", "planid=".$teacherplan->id." AND objectiveid NOT IN (".$usedobjectiveids.")");
    }

    return update_record("teacherplan", $teacherplan);
}

function teacherplan_delete_instance($id) {
// Given an object containing the teacherplan data
// this function will permanently delete the instance
// and any data that depends on it.

    if (! (delete_records("teacherplan", "id", $id) && 
           delete_records("teacherplan_objectives_met", "planid", $id))) {
        return false;
    }

    return true;
}


function teacherplan_user_outline($course, $user, $mod, $teacherplan) {
    if ($logs = get_records_select("log", "userid='$user->id' AND module='teacherplan'
                                           AND action='view' AND info='$teacherplan->id'", "time ASC")) {

        $numviews = count($logs);
        $lastlog = array_pop($logs);

        $result->info = get_string("numviews", "", $numviews);
        $result->time = $lastlog->time;

        return $result;
    }
    return NULL;
}


function teacherplan_user_complete($course, $user, $mod, $teacherplan) {
    global $CFG;

    if ($logs = get_records_select("log", "userid='$user->id' AND module='teacherplan'
                                           AND action='view' AND info='$teacherplan->id'", "time ASC")) {
        $numviews = count($logs);
        $lastlog = array_pop($logs);

        $strmostrecently = get_string("mostrecently");
        $strnumviews = get_string("numviews", "", $numviews);

        echo "$strnumviews - $strmostrecently ".userdate($lastlog->time);

    } else {
        print_string("neverseen", "teacherplan");
    }

    return true;
}

function teacherplan_cron() {
  return true;
}

function teacherplan_print_recent_activity() {
  return false;
}

function teacherplan_get_participants($teacherplanid) {
//Returns the users with data in one teacherplan
//(NONE, byt must exists on EVERY mod !!)

    return false;
}

function teacherplan_get_coursemodule_info($coursemodule) {
/// Given a course_module object, this function returns any
/// "extra" information that may be needed when printing
/// this activity in a course listing.
///
/// See get_array_of_activities() in course/lib.php
///
   return NULL;
}

function teacherplan_grades($teacherplanid) {
/// Must return an array of grades for a given instance of this module, 
/// indexed by user.  It also returns a maximum allowed grade.

    return NULL;
}

/* Provide a button link to the module browse window
*
*  courseid      int       course id
*  name          string    name and id of the button
*  receiver      string    object receiving the link to the module
*  returnstring  boolean   If true, return button link, otherwise echo it
*/
function teacherplan_module_browse_button($courseid, $name, $receiver, $returnstring=false) {
 
    $retval  = '<input type="button" name="'.$name.'" id="'.$name.'" onclick=';
    $retval .= "\"return openpopup('/mod/teacherplan/modlink.php?recv=".$receiver;
    $retval .= "&id=".$courseid."', 'modulelink', ";
    $retval .= "'height=150,width=650,scrollbars=1,resizable=1', false)\"";
    $retval .= 'value="'.get_string('modlinkbtntext', 'teacherplan').'"/>';
    
    if ($returnstring) {
        return $retval;
    } else {
        echo $retval;
    }
}
?>
