<?php
    require_once("$CFG->dirroot/config.php");
    require_once("$CFG->dirroot/mod/teacherplan/lib.php");
    require_once("$CFG->dirroot/mod/teacherplan/objectives.php");
    require_once("$CFG->dirroot/mod/teacherplan/objectives.js");
    global $usehtmleditor;
    
    if (!empty($form->course)) {
        if (! $course = get_record("course", "id", $form->course)) {
            error(get_string('errcoursemisconfigured', 'teacherplan'));
        }
    }
    
    if (empty($form->name)) {
        $form->name = "";
    }

    if (empty($form->plan)) {
        $form->plan = "";
    }

    if (empty($form->assessment)) {
        $form->assessment = "";
    }

    if (empty($form->materials)) {
        $form->materials = "";
    }

    if (!isset($form->plandate)) {
        if (isset($form->timemodified)) {
            $form->plandate = $form->timemodified;
        } else {
            $form->plandate = time();
        }
    } 
    
    if (!isset($form->multiday)) {
        $form->multiday = false;
    }
    
    if (!isset($form->planenddate)) {
        $form->planenddate = $form->plandate;
    }
    
    if (!isset($form->period)) {
        $form->period = 1;
    }
?>
<style type="text/css">
/*--------------------------------------------------
  REQUIRED to hide the non-active tab content.
  But do not hide them in the print stylesheet!
  --------------------------------------------------*/
.tabberlive .tabbertabhide {
 display:none;
}

/*--------------------------------------------------
  .tabber = before the tabber interface is set up
  .tabberlive = after the tabber interface is set up
  --------------------------------------------------*/
.tabber{display:none;}
.tabberlive {
 margin-top:1em;
}

/*--------------------------------------------------
  ul.tabbernav = the tab navigation list
  li.tabberactive = the active tab
  --------------------------------------------------*/
ul.tabbernav
{
 margin:0;
 padding: 3px 0;
 border-bottom: 1px solid #778;
 font: bold 12px Verdana, sans-serif;
}

ul.tabbernav li
{
 list-style: none;
 margin: 0;
 display: inline;
}

ul.tabbernav li a
{
 padding: 3px 0.5em;
 margin-left: 3px;
 border: 1px solid #778;
 border-bottom: none;
 background: #DDE;
 text-decoration: none;
}

ul.tabbernav li a:link { color: #448; }
ul.tabbernav li a:visited { color: #667; }

ul.tabbernav li a:hover
{
 color: #000;
 background: #AAE;
 border-color: #227;
}

ul.tabbernav li.tabberactive a
{
 background-color: #fff;
 border-bottom: 1px solid #fff;
}

ul.tabbernav li.tabberactive a:hover
{
 color: #000;
 background: white;
 border-bottom: 1px solid white;
}

/*--------------------------------------------------
  .tabbertab = the tab content
  Add style only after the tabber interface is set up (.tabberlive)
  --------------------------------------------------*/
.tabberlive .tabbertab {
 padding:5px;
 border:1px solid #aaa;
 border-top:0;

 /* If you don't want the tab size changing whenever a tab is changed
    you can set a fixed height */

 /* height:200px; */

 /* If you set a fix height set overflow to auto and you will get a
    scrollbar when necessary */

 /* overflow:auto; */
}

/* If desired, hide the heading since a heading is provided by the tab */
.tabberlive .tabbertab h2 {
 display:none;
}
.tabberlive .tabbertab h3 {
 display:none;
}

/* Example of using an ID to set different styles for the tabs on the page */
.tabberlive#tab1 {
}
.tabberlive#tab2 {
}
.tabberlive#tab2 .tabbertab {
 height:200px;
 overflow:auto;
}
</style>

<script type="text/javascript">
<!--
   var tabberOptions = {manualStartup:true};
   var endplandateitems = ['planendday','planendmonth','planendyear'];

<?php
    echo 'var standardslist = [';
    if ($list = get_standards_benchmarks_array(-1, $form->course)) {
        $first = true;
        foreach ($list as $item) {
            if ($first) {
                $first = false;
            } else {
                echo ",\n ";
            }
            
            echo "'<a title=\"".addslashes(trim($item->standard))."\">".addslashes($item->standarddesc)."</a>'";
        }
    }
    echo "];\n"; 

?>

    function updateObjectives(optionList, objectivesarrname, reactfunc) {
        var objectives = document.form.elements[objectivesarrname];
        var selectedList = new Array(objectives.options.length);
    
        for (var i=0; i < objectives.options.length; i++) {
            if (objectives.options[i].selected){
                selectedList[i] = objectives.options[i].value;
            }
        }
    
        objectives.options.length = 0;
    
        for (var j=0; j < optionList.options.length; j++) {
            var newData = new Option(optionList.options[j].text, optionList.options[j].value);
            newData.selected = false;
            for (var i=0; i < selectedList.length; i++) {
                if (newData.value == selectedList[i]) {
                    newData.selected = true;
                }
            }
            objectives.options.add(newData, objectives.options.length);
        }
    
        if (reactfunc != '') {
            eval(reactfunc+'()');
        }
    }
    function showobjectives() {
        var selobjectives = document.form.elements['selobjectives[]'];
        var objDiv = document.getElementById('objchosen');
        var objectives = document.form.elements['objectives'];
        
        objectives.value = '';
        
        objDiv.innerHTML = '';
        for (var i=0; i < selobjectives.options.length; i++) {
            if (selobjectives.options[i].selected) {
                objDiv.innerHTML = objDiv.innerHTML + selobjectives.options[i].text;
                objDiv.innerHTML = objDiv.innerHTML + ' (<?php print_string('standardlabel', 'teacherplan') ?> '+standardslist[i]+')<br>';
                objectives.value = objectives.value + selobjectives.options[i].value + ':';
            }
        }   
         
        if (objDiv.innerHTML == '') {
          objDiv.innerHTML = '<center><i><?php print_string("noobjectivesselected", "teacherplan") ?></i></center>';
        } 
    }
-->
</script>
<script type="text/javascript" src="<?php echo "{$CFG->wwwroot}/mod/teacherplan/tabber.js" ?>" ></script>
<form name="form" method="post" action="<?php echo "$CFG->wwwroot/course/mod.php" ?>">

<input type="hidden" name="course"       value="<?php p($form->course) ?>" />
<input type="hidden" name="sesskey"      value="<?php p($form->sesskey) ?>" />
<input type="hidden" name="coursemodule" value="<?php p($form->coursemodule) ?>" />
<input type="hidden" name="section"      value="<?php p($form->section) ?>" />
<input type="hidden" name="module"       value="<?php p($form->module) ?>" />
<input type="hidden" name="modulename"   value="<?php p($form->modulename) ?>" />
<input type="hidden" name="instance"     value="<?php p($form->instance) ?>" />
<input type="hidden" name="mode"         value="<?php p($form->mode) ?>" />
<input type="hidden" name="objectives"   value="" />


<table cellpadding="5">
<tr valign="top">
    <td align="left" colspan="2">
    <b><?php print_string("name") ?>:</b>&nbsp;
    <input type="text" name="name" size="65" value="<?php p($form->name) ?>" alt="<?php print_string('name') ?>" />
    </td>
</tr>
<tr>
    <td colspan="2">
    <div class="tabber">
    <div class="tabbertab tabbertabdefault" title="<?php print_string("objectivestexttitle", "teacherplan") ?>">
        <table cellpadding="5">
        <tr valign="top">
            <td align="left">
                <?php teacherplan_editobjectives_link($course->id, "selobjectives", "showobjectives") ?>
            </td>
            <td align="right">
                <?php helpbutton("objectives", get_string("objectiveshelptitle", "teacherplan"), "teacherplan", true, true); ?>
            </td>
        </tr>
        <tr>
            <td colspan="2">
                <h3><?php print_string("selectobjectives", "teacherplan") ?></h3>
                <?php print_objectives_selectbox($course->id, $form->instance, "selobjectives", true, "return showobjectives()") ?><br><br>
                <h3><?php print_string("selectedobjectives", "teacherplan") ?></h3>
                <p id="objchosen" style="width: 600px; border: 2px solid black; padding: 2px"></p>
            </td> 
        </tr>
        </table>   
    </div>
    <div class="tabbertab" title="<?php print_string("plantexttitle", 'teacherplan') ?>">
        <table cellpadding="5">
        <tr valign="top">
            <td align="right" colspan="2">
                <?php helpbutton("plan", get_string("planhelptitle", "teacherplan"), "teacherplan", true, true); ?>
            </td>
        <tr valign="top">
            <td align="right" nowrap="nowrap">
                <?php  helpbutton("text", get_string("helptext"), "moodle", true, true) ?><br />
                <?php  emoticonhelpbutton("theform", "plan") ?> <br />
            </td>
            <td style="width:550px">
                <?php print_textarea(true, 30, 72, 500, 600, "plan", $form->plan); ?>
            </td>
        </tr>
        </table>
    </div>
    <div class="tabbertab" title="<?php print_string("assessmenttitle", "teacherplan"); ?>">
        <table cellpadding="5">
        <tr valign="top">
            <td align="right" colspan="2">
                <?php teacherplan_module_browse_button($form->course, 'assessmentaddlink', 'assessment') ?>
            </td>
        </tr>
        <tr valign="top">
            <td align="right">
                <b><?php print_string("assessmenttitle", "teacherplan"); ?></b><br />
                <?php  helpbutton("text", get_string("helptext"), "moodle", true, true) ?><br />
                <?php  emoticonhelpbutton("theform", "plan") ?>
            </td>
            <td style="width:550px">
                <?php print_textarea(true, 30, 72, 500, 600, "assessment", $form->assessment); ?>
            </td>
        </tr>
        </table>
    </div>
    <div class="tabbertab" title="<?php print_string("materialstext", "teacherplan"); ?>">
        <table cellpadding="5">
        <tr valign="top">
            <td align="right" colspan="2">
                <?php teacherplan_module_browse_button($form->course, 'materialsaddlink', 'materials') ?>
            </td>
        </tr>
        <tr valign="top">
            <td align="right">
                <b><?php print_string("materialstext", "teacherplan"); ?></b><br />
                <?php  helpbutton("text", get_string("helptext"), "moodle", true, true) ?><br />
                <?php  emoticonhelpbutton("theform", "plan") ?>
            </td>
            <td style="width:550px">
                <?php print_textarea(true, 30, 90, 500, 600, "materials", $form->materials); ?>
            </td>
        </tr>
        </table>
    </div>
    </div>
    </td>
</tr>
<tr>
    <td>
    <b><?php print_string("plandatetext", "teacherplan") ?>:</b>&nbsp;
    <?php print_date_selector("planday", "planmonth", "planyear", $form->plandate); ?> 
    </td>
    <td><b><?php print_string('multidaylabel', 'teacherplan') ?></b>&nbsp;
    <input name="multiday" id="multiday" type="checkbox"  value="1" onclick="return lockoptions('form', 'multiday', endplandateitems);" <?php if ($form->multiday) echo 'checked="checked"' ?> />
    <b><?php print_string("planenddatelabel", "teacherplan") ?>:</b>
    <?php print_date_selector('planendday', 'planendmonth', 'planendyear', $form->planenddate); ?> 
        <input type="hidden" name="hplanendday"    value="0" />
        <input type="hidden" name="hplanendmonth"  value="0" />
        <input type="hidden" name="hplanendyear"   value="0" />
    </td>   
</tr>
<tr>
    <td align="left">
    <b><?php print_string("periodtitle", "teacherplan") ?>:</b>&nbsp;
    <select name="period">
    <?php 
    for ($i=1; $i<15; $i++) {
        echo "<option value=".$i." ".($i == $form->period ?"selected=\"selected\"":"").">".$i."</option>";
    } ?>
    </select>
    </td>
    <td align="left">
    <?php print_visible_setting($form); ?>
    </td>
</tr> 
</table>
<div align="center">
<input type="submit" value="<?php print_string('savechanges') ?>" />
</div>
</form>
<?php
//    use_html_editor('plan');
//    use_html_editor('assessment');
//    use_html_editor('materials');
    $usehtmleditor=false;
?>
<script type="text/javascript">
<!--

edit_plan = new HTMLArea('edit-plan');
var config = edit_plan.config;
config.pageStyle = "body { background-color: #ffffff; font-family: Trebuchet MS,Verdana,Arial,Helvetica,sans-serif; }";
config.killWordOnPaste = true;
config.width = 600;
config.fontname = {
"Trebuchet":	'Trebuchet MS,Verdana,Arial,Helvetica,sans-serif',
"Arial":	'arial,helvetica,sans-serif',
"Courier New":	'courier new,courier,monospace',
"Georgia":	'georgia,times new roman,times,serif',
"Tahoma":	'tahoma,arial,helvetica,sans-serif',
"Times New Roman":	'times new roman,times,serif',
"Verdana":	'verdana,arial,helvetica,sans-serif',
"Impact":	'impact',
"Wingdings":	'wingdings'};
edit_plan.generate();

edit_assessment = new HTMLArea('edit-assessment');
var config = edit_assessment.config;
config.pageStyle = "body { background-color: #ffffff; font-family: Trebuchet MS,Verdana,Arial,Helvetica,sans-serif; }";
config.killWordOnPaste = true;
config.width = 600;
config.fontname = {
"Trebuchet":	'Trebuchet MS,Verdana,Arial,Helvetica,sans-serif',
"Arial":	'arial,helvetica,sans-serif',
"Courier New":	'courier new,courier,monospace',
"Georgia":	'georgia,times new roman,times,serif',
"Tahoma":	'tahoma,arial,helvetica,sans-serif',
"Times New Roman":	'times new roman,times,serif',
"Verdana":	'verdana,arial,helvetica,sans-serif',
"Impact":	'impact',
"Wingdings":	'wingdings'};
edit_assessment.generate();

edit_materials = new HTMLArea('edit-materials');
var config = edit_materials.config;
config.pageStyle = "body { background-color: #ffffff; font-family: Trebuchet MS,Verdana,Arial,Helvetica,sans-serif; }";
config.killWordOnPaste = true;
config.width = 600;
config.fontname = {
"Trebuchet":	'Trebuchet MS,Verdana,Arial,Helvetica,sans-serif',
"Arial":	'arial,helvetica,sans-serif',
"Courier New":	'courier new,courier,monospace',
"Georgia":	'georgia,times new roman,times,serif',
"Tahoma":	'tahoma,arial,helvetica,sans-serif',
"Times New Roman":	'times new roman,times,serif',
"Verdana":	'verdana,arial,helvetica,sans-serif',
"Impact":	'impact',
"Wingdings":	'wingdings'};
edit_materials.generate();

    showobjectives();
    tabberAutomatic(tabberOptions);
    
    var matcharray = [['plan', edit_plan], ['assessment', edit_assessment], ['materials', edit_materials]];
                      
    function insertToTextArea(recvname, html) {
        for (var i = 0; i < matcharray.length; i++) {
            if (matcharray[i][0] == recvname) {
                try {
                    // Make sure that editor has focus
                    matcharray[i][1].focusEditor();
                    matcharray[i][1].insertHTML(html);  // inserts  contents
                } catch (e) {
                    alert('First click in the HTML field and then try this again.');
                }
            }       
        }
    }
    
<?php 
    if (!$multiday) echo "lockoptions('form','multiday', endplandateitems);\n";
?>

-->  
</script>