<?PHP
    require_once("../../config.php");
    global $CFG;

    $courseid = optional_param('id', '', PARAM_INT);
    $receiver = optional_param('recv', 'nogood', PARAM_NOTAGS);
    $lastsection = optional_param('getsection', -1, PARAM_INT);
    $lasttype = optional_param('getactivity', -1, PARAM_INT);

    if (! $course = get_record('course', 'id', $courseid)) {
        error('Course ID is incorrect');
    }
?>
<head>
<title><?php print_string('modlinktitle', 'teacherplan'); ?></title>
<script language="JavaScript" type="text/javascript">

    function closeUp(modname) {
        var recvname = '<?PHP echo $receiver ?>';
        if (recvname) {
            var idnum = document.getmodform.chooseitem.value;
            var itemname = document.getmodform.chooseitem.options[document.getmodform.chooseitem.selectedIndex].text;
            
            var linkStr = '<?php echo $CFG->wwwroot ?>/mod/'+modname+'/view.php?id='+idnum;
            opener.insertToTextArea(recvname, '<a href="'+linkStr+'">'+itemname+'</a>');
        }
        window.close();
    }
    
    function submitsection() {
        if (document.getmodform.getsection.value != -1) {
            document.getmodform.submit();
        }
    }
    
    function submitactivity() {
        if (document.getmodform.getactivity.value != -1) {
            document.getmodform.submit();
        }
    }
    
    function refreshlinktext(modname) {
        var dispArea = document.getElementById('resultlink');
        var idnum = document.getmodform.chooseitem.value;
        
        if (idnum !== -1) {
            var linkstub = '/mod/'+modname+'/view.php?id='+idnum;
            var linkStr = '<?php echo $CFG->wwwroot ?>'+linkstub;
    
            dispStr = '<a target="Activity" onclick="return openpopup(\''+linkstub+'\', ';
            dispStr += ' \'Activity\', \'height=600,width=620,scrollbars=1,resizable=1\', false)" href="'+linkStr+'">'+linkStr+'</a>';     
        } else {
            dispStr = '<i><?php print_string('modlinknotchosen', 'teacherplan') ?></i>';
        }
        dispArea.innerHTML = dispStr;
    }
</script>
</head>
<body>
<form name="getmodform" method="POST" action="<?php echo "$CFG->wwwroot/mod/teacherplan/modlink.php" ?>">
<input type="hidden" name="id"         value="<?php p($courseid) ?>" />
<input type="hidden" name="recv"       value="<?php p($receiver) ?>" />
<table>
<tr>
    <td>
        <select name="getsection" id="getsection" style="width:150px" onchange="return submitsection()">
        <option value="-1"><?php print_string('modlinkselectsectiona', 'teacherplan'); ?></option>
        <?php
            $weekstr = get_string('week');
            $topicstr = get_string('topic');
            $startweekdate = $course->startdate + 7200;    // this should be 0:00 Monday of that week
                                                           // Add two hours to avoid possible DST problems
            $weekofseconds = 604800;
            $fivedaysofseconds = 518400;
            $strftimedateshort = ' '.get_string('strftimedateshort');
            
            if ($sections = get_records('course_sections', 'course', $courseid, 'section ASC')) {
                foreach ($sections as $section) {
                    echo '<option ';
                    if ($section->id == $lastsection) {
                        echo 'selected ';
                    }
                    
                    //Get proper section name
                    if ($section->section == 0) {
                        $sectionname = get_string('modlinkgeneralsection', 'teacherplan');
                    } elseif ($course->format == 'weeks') {
                        $weekdate = $startweekdate + ($section->section - 1)*$weekofseconds;
                        $weekday = userdate($weekdate, $strftimedateshort);
                        $endweekday = userdate($weekdate+$fivedaysofseconds, $strftimedateshort);
                        $sectionname = $weekstr.$weekday.' -'.$endweekday;
                    } else {
                        $sectionname = $topicstr.' '.$section->section;
                    }
                    
                    echo 'value="'.$section->id.'" >'.$sectionname.'</option>'."\n";
                }
            }
        ?>
        </select>
    </td>
    <td>
        <div style="width:300px" align="center"><?php print_string('modlinklinkheading', 'teacherplan') ?></p>
    </td>
</tr>
<tr>
    <td>
        <select name="getactivity" id="getactivity" style="width:150px" onchange="return submitactivity()">
        <option value="-1"><?php print_string('modlinkselecttypea', 'teacherplan'); ?></option>
        <?php
            if ($lastsection !== -1) {
                $coursetable = $CFG->prefix.'course_modules';
                $moduletable = $CFG->prefix.'modules';
                $sql  = 'SELECT DISTINCT '.$moduletable.'.name AS name, '.$coursetable.'.module AS id ';
                $sql .= 'FROM '.$moduletable.' INNER JOIN '.$coursetable.' ON ';
                $sql .= $moduletable.'.id='.$coursetable.'.module WHERE ';
                $sql .= $coursetable.".course='".$courseid."' AND ";
                $sql .= $coursetable.".section='".$lastsection."' ORDER BY name";
                if ($modules = get_records_sql($sql)) {
                    foreach ($modules as $module) {
                        echo '<option ';
                        if ($module->id == $lasttype) {
                            echo 'selected ';
                            $selectedmod = $module->name;
                        }
                        echo 'value="'.$module->id.'" >'.get_string('modulename', $module->name).'</option>'."\n";
                    }
                }
            }
        ?>
        </select>
    </td>
    <td rowspan="2">
        <div align="center" style="width:300px" name="resultlink" id="resultlink"><i><?php print_string('modlinknotchosen', 'teacherplan') ?></i></div>
    </td>
</tr>
<tr>
    <td>
        <select name="chooseitem" id="chooseitem" style="width:200px" onchange="return refreshlinktext('<?php echo $selectedmod ?>')">
        <option value="-1"><?php print_string('modlinkselectactivitya', 'teacherplan'); ?></option>
        <?php
            if ($lastsection !== -1 and $lasttype !== -1 and !empty($selectedmod)) {
                $sql = "course='".$courseid."' AND module='".$lasttype."' AND section='".$lastsection."'";
                if ($items = get_records_select('course_modules', $sql)) {
                    foreach ($items as $item) {
                        if ($instance = get_record($selectedmod, 'id', $item->instance)) {
                            echo '<option value="'.$item->id.'" >'.$instance->name.'</option>'."\n";
                        }
                    }
                }
            }
        ?>
        </select>
    </td>
</tr>
</table>
<center><input type="button" value="<?php print_string('modlinksubmitbtn', 'teacherplan') ?>" name="submitbtn" onclick="return closeUp('<?php echo $selectedmod ?>')"/></center>
</form>
</body>