<?php  // $Id: view.php,v 1.2 2006/07/13 13:05:23 scarletpumpkin Exp $

    require_once("../../config.php");
    require_once("lib.php");
 
    $id = optional_param('id', 0, PARAM_INT);    // Course Module ID
    $tp  = optional_param('tp', 0, PARAM_INT);  // Teacherplan

    if (!empty($CFG->forcelogin)) {
        require_login();
    }

    if ($tp) {  // Two ways to specify the teacherplan
        if (! $teacherplan = get_record('teacherplan', 'id', $tp)) {
            error(get_string("errteacherplanidincorrect", "teacherplan"));
        }

        if (! $cm = get_coursemodule_from_instance('teacherplan', $teacherplan->id, $teacherplan->course)) {
            error(get_string("errcmidincorrect", "teacherplan"));
        }

    } else if ($id) {
        if (! $cm = get_record('course_modules', 'id', $id)) {
            error(get_string("errcmidincorrect", "teacherplan"));
        }
    } else {
        error(get_string("errnovalidparams", "teacherplan"));
    }

/// Set up some shorthand variables
    if (! $course = get_record("course", "id", $cm->course)) {
        error(get_string("errcoursemisconfigured", "teacherplan"));
    }

    require_course_login($course, true, $cm);

    if (! $teacherplan = get_record("teacherplan", "id", $cm->instance)) {
        error(get_string("errteacherplanidincorrect", "teacherplan"));
    }
    
    $strteacherplan  = get_string("modulename", "teacherplan");
    $strteacherplans = get_string("modulenameplural", "teacherplan");

    if ($course->category) {
        $navigation = "<a target=\"{$CFG->framename}\" href=\"$CFG->wwwroot/course/view.php?id={$course->id}\">{$course->shortname}</a> -> "."<a target=\"{$CFG->framename}\" href=\"index.php?id={$course->id}\">$strteacherplans</a> ->";
    } else {
        $navigation = "<a target=\"{$CFG->framename}\" href=\"index.php?id={$course->id}\">$strteacherplans</a> ->";
    }

    if (!$cm->visible and !isteacher($course->id)) {
        $pagetitle = strip_tags($course->shortname.': '.$strteacherplan);
        print_header($pagetitle, $course->fullname, "$navigation $strteacherplan", "", "", true, '', navmenu($course, $cm));
        notice(get_string("activityiscurrentlyhidden"), "$CFG->wwwroot/course/view.php?id={$course->id}");
    }

    $pagetitle = strip_tags($course->shortname.': '.format_string($teacherplan->name));
    $formatoptions->noclean = true;

// Display header
    add_to_log($course->id, "teacherplan", "view", "view.php?id={$cm->id}", $teacherplan->id, $cm->id);
    print_header($pagetitle, $course->fullname, "$navigation ".format_string($teacherplan->name),
                  "", "", true, update_module_button($cm->id, $course->id, $strteacherplan), 
                  navmenu($course, $cm));
// Display plan and objectives included
    echo "<table width=600><tr>";
    echo "<th align=center colspan=2><font size=\"6\">$teacherplan->name</font></th></tr>";

    $objectivestext = teacherplan_get_pretty_objectives($teacherplan->id, $teacherplan->course, false);
    if (empty($objectivestext)) {
        $objectivestext = get_string("noobjectivesgiven", "teacherplan");
    }

    echo "<tr><td valign=\"top\"><font size=\"3\"><b>".get_string('objectivestexttitle', 'teacherplan')."</b></font></td><td>";
    print_simple_box_start('left', '600');
    echo "<font size=\"3\">$objectivestext</font>";
    print_simple_box_end();
    echo "</td></tr>";

    $plantext = format_text($teacherplan->plan, FORMAT_HTML, NULL, $course->id); 
    echo "<tr><td valign=\"top\"><font size=\"3\"><b>".get_string('plantexttitle', 'teacherplan')."</b></font></td><td>";
    print_simple_box_start('left', '600');
    echo "<font size=\"3\">$plantext</font>";
    print_simple_box_end();
    echo "</td></tr>";
    
    $assesstext = format_text($teacherplan->assessment, FORMAT_HTML, NULL, $course->id); 
    if (empty($assesstext)) {
        $assesstext = "<i>".get_string('noassessment', 'teacherplan')."</i>";
    }     
    echo "<tr><td valign=\"top\"><font size=\"3\"><b>".get_string('assessmenttitle', 'teacherplan')."</b></font></td><td>";
    print_simple_box_start('left', '600');
    echo "<font size=\"3\">$assesstext</font>";
    print_simple_box_end();
    echo "</td></tr>";
    
    $materialstext = format_text($teacherplan->materials, FORMAT_HTML, NULL, $course->id); 
    if (empty($materialstext)) {
        $materialstext = "<i>".get_string('nomaterials', 'teacherplan')."</i>";
    }     
    echo "<tr><td valign=\"top\"><font size=\"3\"><b>".get_string('materialstext', 'teacherplan')."</b></font></td><td>";
    print_simple_box_start('left', '600');
    echo "<font size=\"3\">$materialstext</font>";
    print_simple_box_end();
    echo "</td></tr>";

    echo "<tr><td><b><font size=\"2\">";
    print_string("periodtitle", 'teacherplan');
    echo "</font></b></td><td><font size=\"2\">&nbsp;";
    echo $teacherplan->period;
    echo "</font></td></tr>";

    echo "<tr><td><b><font size=\"2\">";
    print_string("plandatetext", 'teacherplan');
    echo "</font></b></td><td><font size=\"2\">&nbsp;";
    if ($teacherplan->plandate == 0) {
        echo "<i>".get_string('nodategiven', 'teacherplan')."</i>";
    } else {
        echo userdate($teacherplan->plandate, "%A, %d %B, %Y");
    }
    
    if ($teacherplan->multiday) {
        echo " - ".userdate($teacherplan->planenddate, "%A, %d %B, %Y");
    }
    echo "</font></td></tr>";

// Close table
    echo "</table><br>";
    
// Display last modified
    $strlastmodified = get_string("lastmodified");
    echo "<center><p><font size=\"1\">$strlastmodified: ".userdate($teacherplan->timemodified)."</font></p></center>";
    
//Display footer
    print_footer($course);
?>
